@echo off
REM SETKEY.BAT makes one key the equal of one character string.
REM The first parameter indicates which key, the second parameter
REM is the string you want DOS to type (followed by ENTER).
REM SETKEY relies on a variable, called KEY, for keeping a record
REM of all function key assignments since the last bootup.
REM the KEY variable is reset each time you boot up, or each
REM time you run SETKEY. Since it relies on the KEY environment
REM variable to updatew its text file record, running SETKEY.BAT
REM is the first time after a reboot causes the text file to be
REM inaccurate. It's wise to write down your function key changes.
REM PROGRAM ORIGINALLY PRINTED IN DOS RESOURCE GUIDE, ALL RIGHTS RESERVED
REM Program typed in by Gerald Lack

if "%1"=="" GOTO help
if "%1"=="?" goto help
if "%1"=="h" goto help
if "%1"=="H" goto help

REM Re-create SETKEY.TXT, if SETKEY.BAT has
rem not been run this session
IF NOT "%KEY"=="" GOTO KEYS
ECHO *** PLEASE NOTE *** > C:\SETKEY.TXT
ECHO KEY ASSIGNMENTS MADE THIS SESSION WITH SETKEY.BAT ARE: >>
ECHO C:\SETKEY.TXT
ECHO. >> C:\SETKEY.TXT
GOTO KEYS

:HELP
PROMPT $E[1;44;33m
ECHO ON
ECHO OFF
CLS
ECHO SETKEY.BAT WAS WRITTEN BY JIM BELL AND PROGRAMMED BY GERALD LACK
ECHO.
ECHO DEVICE=ANSI.SYS must be in your config.sys file for this program
ECHO to work. The first parameter for the function key
ECHO MUST be in uppercase. No spaces are allowed except the spaces
ECHO preceding each parameter. Using a third parameter of -M
ECHO supresses the display of the SETKEY.TXT record.
ECHO.
ECHO                *** Examples of use ***
ECHO SETKEY F1 DIR/P -M   Sets F1 to list the directory (no message)
ECHO.
ECHO SETKEY SF1 MENU.BAT  Sets Shift-F1 to run the file MENU.BAT
ECHO.
ECHO SETKEY CF1 123.BAT   Sets Control-F1 to run Lotus 1-2-3
ECHO.
ECHO SETKEY AF1 CD\UTIL   Sets Alt-F1 to change to the \UTIL directory
ECHO
ECHO.
ECHO When you continue, the screen will clear.
PAUSE
PROMPT $e[0;40;37m $P$G
ECHO ON
ECHO OFF
CLS
GOTO END

:KEYS
SET KEY=0
IF %1==F1 SET KEY=59      
IF %1==F2 SET KEY=60        
IF %1==F3 SET KEY=61          
IF %1==F4 SET KEY=62        
IF %1==F5 SET KEY=63        
IF %1==F6 SET KEY=64        
IF %1==F7 SET KEY=65        
IF %1==F8 SET KEY=66        
IF %1==F9 SET KEY=67        
IF %1==F10 SET KEY=68        
IF %1==F11 SET KEY=133       
IF %1==F12 SET KEY=134       
IF %1==SF1 SET KEY=84        
IF %1==SF2 SET KEY=85      
IF %1==SF3 SET KEY=86        
IF %1==SF4 SET KEY=87        
IF %1==SF5 SET KEY=88        
IF %1==SF6 SET KEY=89        
IF %1==SF7 SET KEY=90        
IF %1==SF8 SET KEY=91        
IF %1==SF9 SET KEY=92        
IF %1==SF10 SET KEY=93        
IF %1==SF11 SET KEY=135       
IF %1==SF12 SET KEY=136      
IF %1==CF1 SET KEY=94        
IF %1==CF2 SET KEY=95       
IF %1==CF3 SET KEY=96        
IF %1==CF4 SET KEY=97      
IF %1==CF5 SET KEY=98      
IF %1==CF6 SET KEY=99        
IF %1==CF7 SET KEY=100     
IF %1==CF8 SET KEY=101       
IF %1==CF9 SET KEY=102       
IF %1==CF10 SET KEY=103       
IF %1==CF11 SET KEY=137       
IF %1==CF12 SET KEY=138       
IF %1==AF1 SET KEY=104       
IF %1==AF2 SET KEY=105      
IF %1==AF3 SET KEY=106       
IF %1==AF4 SET KEY=107       
IF %1==AF5 SET KEY=108       
IF %1==AF6 SET KEY=109       
IF %1==AF7 SET KEY=110       
IF %1==AF8 SET KEY=111       
IF %1==AF9 SET KEY=112       
IF %1==AF10 SET KEY=113     
IF %1==AF11 SET KEY=139       
IF %1==AF12 SET KEY=140       
IF %KEY%==0 GOTO HELP

:ADDTEXT
ECHO  %1 HAS BEEN SET TO "%2" >> c:\SETKEY.TXT
PROMPT $e[0;%KEY%;"%2";13p
ECHO ON
ECHO OFF
IF "%3"=="-M" GOTO END
CLS
TYPE C:\SETKEY.TXT

:END
PROMPT $P$G
